import java.awt.*;
import java.util.Vector;

public class Wall
{
  int from,to,base;
  int type;
  boolean isInternal;
  
  final static int LEFT=0;
  final static int RIGHT=1;
  final static int UPPER=2;
  final static int LOWER=3;
    
  public Wall(int from, int to, int base, int type, boolean internal)
      {
	this.from=from;
	this.to=to;
	this.type=type;
	this.base=base;
	this.isInternal=internal;
	from_less_than_to();
      }

  public Wall(int from, int to, int base, int type)
      {
	this.from=from;
	this.to=to;
	this.type=type;
	this.base=base;
	this.isInternal=false;
	from_less_than_to();
      }

  private void  from_less_than_to()
      {
	if(from>to)
	    {
	      int w=from;
	      from=to;
	      to=w;
	    }
      }

  public boolean outside(Point p)
      {
	if(!isInternal)
	  return distance(p)<0;
	else 
	  return false;
      }

  public int distance(Point p)
      {
	int VeryBig=100000;
	switch(type)
	    {
	    case LEFT:
	      // left wall
	      if(p.y>=from&&p.y<=to)
		return p.x-base;
	      break;
	    case RIGHT:
	      // right wall
	      if(p.y>=from&&p.y<=to)
		return base-p.x;
	      break;
	    case UPPER:
	      // up wall
	      if(p.x>=from&&p.x<=to)
		return p.y-base;
	      break;
	    case LOWER:
	      if(p.x>=from&&p.x<=to)
		return base-p.y;
	      break;
	    }
	return VeryBig;
      }
  public int get_base()
      {
	return base;
      }
  public int get_type()
      {
	return type;
      }

  public int get_from()
      {
	return from;
      }
  
  public int get_to()
      {
	return to;
      }
  
  protected void set_to(int newto)
      {
	to=newto;
      }
  
  protected void set_from(int newfrom)
      {
	from=newfrom;
      }
  
  
}
